unit ADH1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, XBase1, ComCtrls;

type
  TF1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label0: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    SpinEdit7: TSpinEdit;
    SpinEdit8: TSpinEdit;
    UpDown1: TUpDown;
    XBase1: TXBase;
    Button1: TButton;
    Button2: TButton;
    Label10: TLabel;
    Label11: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Button3: TButton;
    XBase2: TXBase;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    XPOSITION: TLabel;
    FIND_BTN: TButton;
    FIND1: TEdit;
    FIND2: TEdit;
    FIND3: TEdit;
    FIND4: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FIND_BTNClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure AFFICHER_RECORD ;
    procedure UPDATE_RECORD ;
    procedure NOUVEAU_RECORD ;
  end;

var
  F1: TF1;

implementation

{$R *.DFM}

uses ADH2 ;

//========================================================
procedure TF1.AFFICHER_RECORD ;
begin
  with XBase1 do begin
     Edit1.Text :=  GetFieldStr('NOM') ;
     Edit2.Text :=  GetFieldStr('PRENOM') ;
     Edit3.Text :=  GetFieldStr('RUE') ;
     Edit4.Text :=  GetFieldStr('VILLE') ;
     Edit5.Text :=  GetFieldDat('DATE_ADH') ;
     Edit6.Text :=  FloatToStr( GetFieldNum('COTISATION') ) ;
     Edit7.Text :=  FloatToStr( GetFieldNum('COEFF') ) ;
     Edit8.Text :=  FloatToStr( GetFieldNum('TAUX' ) ) ;
     SpinEdit7.Value := GetFieldInt('NB_ENFANTS') ;
     SpinEdit8.Value := GetFieldInt('NUM_ADH') ;
     XPOSITION.Caption := IntToStr(Recno) ;
  end ;
end ;
//========================================================
procedure TF1.UPDATE_RECORD ;
begin
  with XBase1 do begin
     UpdFieldStr('NOM'        , Edit1.Text ) ;
     UpdFieldStr('PRENOM'     , Edit2.Text ) ;
     UpdFieldStr('RUE'        , Edit3.Text ) ;
     UpdFieldStr('VILLE'      , Edit4.Text ) ;
     UpdFieldDat('DATE_ADH'   , Edit5.Text ) ;
     UpdFieldNum('COTISATION' , StrToFloat( Edit6.Text ) ) ;
     UpdFieldNum('COEFF'      , StrToFloat( Edit7.Text ) ) ;
     UpdFieldNum('TAUX'       , StrToFloat( Edit8.Text ) ) ;
     UpdFieldInt('NB_ENFANTS' , SpinEdit7.Value ) ;
     UpdFieldInt('NUM_ADH'    , SpinEdit8.Value ) ;
     // PostChanges ;  // non indispensable si AutoUpdate = true
  end ;
end ;
//========================================================
procedure TF1.NOUVEAU_RECORD ;
var X1 : cardinal ;
begin
  with XBase1 do begin
     X1 := RecordCount + 1 ;
     AppendBlank ;   // PostChanges  , et  GotoEOF  sont inclus
     if X1 <> RecNo then begin
          ShowMessage('BIZARRE sur APPENDBLANK ') ;
          GotoRecord(X1) ;
     end ;
     UpdFieldStr('NOM'        , 'nom de famille' ) ;
     UpdFieldStr('PRENOM'     , 'prnoms'        ) ;
     UpdFieldStr('RUE'        , 'n et rue '     ) ;
     UpdFieldStr('VILLE'      , 'ville postale'  ) ;
     UpdFieldDat('DATE_ADH'   , '01/12/2002'     ) ;
     UpdFieldNum('COTISATION' , 125.89           ) ;
     UpdFieldNum('COEFF'      , 2.34567          ) ;
     UpdFieldNum('TAUX'       , 34.567           ) ;
     UpdFieldInt('NB_ENFANTS' , 2                ) ;
     UpdFieldInt('NUM_ADH'    , X1               ) ;
     PostChanges ;
     // GotoEOF ;
     AFFICHER_RECORD ;
  end ;
end ;

//========================================================
procedure TF1.FormCreate(Sender: TObject);
begin
   XBase1.FileName := 'ADHERENT.DBF' ;
   XBase1.AutoUpDate := true ; // ne fonctionne pas
   XBase1.Active   := true ;
   XBase1.DebugErr := true ;
   if XBase1.RecordCount = 0 then
            NOUVEAU_RECORD ;
   Xbase1.GotoBOF  ;
   AFFICHER_RECORD ;
end;

//========================================================
procedure TF1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
var X1 : cardinal ;
    // X2 : smallint ;
begin
   X1 := XBase1.Recno ;
   UPDATE_RECORD ;

   // PREMIERE VARIANTE
(*
   X2 := (Sender as TUpDown).Position ; // of Incrmenteur invisible du composant ;
   if X2 < 1 then begin
             ShowMessage('PREMIER RECORD' ) ;
             X2 := 1 ;
             end ;
   if X2 > XBase1.RecordCount then begin
             ShowMessage('DERNIER RECORD' ) ;
             X2 := XBase1.RecordCount ;
             end ;
   (Sender as TUpDown).Position := X2 ;
   XBase1.GotoRecord(X2) ;
*)

   // DEUXIEME VARIANTE : pour marcher il faut UpDown1.Min < -999 et .Max > +999
   case Button of
        btPrev :  begin
                  if X1 > 1 then  begin
                            dec(X1) ;
                            XBase1.GotoPrev ; // idem  XBase1.GotoRecord(X1)
                            end
                  else ShowMessage('PREMIER RECORD' ) ;
                  end ;
        btNext :  begin
                  if X1 < XBase1.RecordCount then begin
                            inc(X1) ;
                            XBase1.GotoNext ; // idem  XBase1.GotoRecord(X1)
                            end
                  else ShowMessage('DERNIER RECORD' ) ;
                  end ;
        else
                  ShowMessage('QUEL BOUTON ?????' ) ;
   end ;
   AFFICHER_RECORD ;
end;

//========================================================
procedure TF1.Button1Click(Sender: TObject);
begin
  NOUVEAU_RECORD ;
end;

//========================================================
procedure TF1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   UPDATE_RECORD ;
   XBase1.Active := false ;
end;

//========================================================
procedure TF1.Button2Click(Sender: TObject);
// var Action: TCloseAction;
begin
   //UPDATE_RECORD ;
   //XBase1.Active := false ;
   //Action := caFree ;
   //FormClose(Sender , Action ) ;
   Close ;
end;

//========================================================
procedure TF1.Button3Click(Sender: TObject);
var
    LISTE1 : TStringList ;
    // X1 : integer ;
begin
    Showmessage('Exemple DBFCreate : Creation du fichier EXEMPLE1.DBF') ;
    LISTE1 := TStringList.Create ;
    with LISTE1 do begin
         Clear ;
         //... ATTENTION , vous ne devez pas avoir deux NOMS identiques !
         Add('CHAMP1 =C12') ;
         Add('CHAMP2 =C23') ;
         Add('NOMBRE3=N6 ') ;
         Add('NOMBRE4=N9 ') ;
         Add('NOMBRE5=N14') ;
         Add('MONTANT1 =N6,2' ) ;
         Add('MONTANT2 =N9,4' ) ;
         Add('MONTANT3 =N15,6') ;
         Add('DATE1  =D    ') ;
         Add('DATE2  =D9,2 ') ;     // stupide Date = 8 car
         Add('DATE3  =D8   ') ;     // inutile Date = 8 car
         Add('LOGIQ1 =L  ') ;
         Add('FINX=C3') ;
    end ;
    XBase2.DBFCreate('EXEMPLE1.DBF' , LISTE1 ) ;
end;

//========================================================
procedure TF1.Button4Click(Sender: TObject);
begin
    Showmessage('Exemple DBFCopyStruct : COPY STRUCT vers fichier EXEMPLE2.DBF') ;
    XBase1.DBFCopyStruct('EXEMPLE2.DBF') ;
end;

//========================================================
procedure TF1.Button5Click(Sender: TObject);
begin
    Showmessage('Exemple DBFCopyFile : COPY TO fichier EXEMPLE3.DBF next 7') ;
    XBase1.DBFCopyFile('EXEMPLE3.DBF' , 7 , false ) ;
end;

//========================================================
procedure TF1.Button6Click(Sender: TObject);
var W_STRLST1 : TStringList ;
    LX1 , J1 : integer ;
    W1  : String[255] ;
begin
    W_STRLST1 := TStringList.Create ;
    Showmessage('Exemple DBFExtractStruct') ;
    XBase1.DBFExtractStruct(W_STRLST1 , true) ;

    Application.CreateForm(TF2, F2);
    with F2.SG2 do begin
         F2.SG2.Cols[0].Text := 'RESULTAT' ;
         F2.SG2.Cols[1].Text := 'NOM du CHAMP' ;
         F2.SG2.Cols[2].Text := 'TYPE' ;
         F2.SG2.Cols[3].Text := 'TAILLE' ;
         F2.SG2.Cols[4].Text := 'DECIMALES' ;
         F2.SG2.Cols[5].Text := 'N Champ' ;
         F2.SG2.ColWidths[0] := 190 ;
         F2.SG2.ColWidths[1] := 120 ;
         F2.SG2.ColWidths[2] :=  70 ;
         F2.SG2.ColWidths[3] :=  90 ;
         F2.SG2.ColWidths[4] :=  90 ;
         F2.SG2.ColWidths[5] :=  50 ;
         for LX1 := 1 to W_STRLST1.Count  do begin
             W1 := W_STRLST1.Strings[LX1 - 1]  ;
             Cells[0 , LX1] := W1 ;
             Cells[5 , LX1] := IntToStr(LX1) ;
             J1 := pos('=' , W1) ;
             Cells[1 , LX1] := copy(W1, 1 , J1-1) ;
             Cells[2 , LX1] := W1[J1+1] ;
             W1 := copy(W1,J1+2,99) ;
             J1 := pos(',' , W1) ;
             if J1 = 0 then begin
                 Cells[3 , LX1] := W1  ;
                 Cells[4 , LX1] := '0' ;
             end else begin
                 Cells[3 , LX1] := copy(W1 , 1 , J1-1) ;
                 Cells[4 , LX1] := copy(W1 , J1+1 ,99) ;
             end ;
         end ;
    end ;
    F2.ShowModal ;
    F2.Release  ;
end;

//========================================================
procedure TF1.FIND_BTNClick(Sender: TObject);
var J1 : integer ;
begin
   XBASE1.SetFind(FIND1.Text , FIND2.Text , FIND3.Text) ;
   J1 := XBASE1.FindRecord(FIND4.Text) ;
   ShowMessage('RECORD trouv ? ' + IntToStr(J1) ) ;
   AFFICHER_RECORD ;
end;

//*********************************************************
end.
